<?php
/*
Plugin Name: WOS Media Categories
Plugin URI: http://suburbia.org.uk
Description: Enables Management of Categories for Media / Attachments.
Version: 1.0
Author: Rick Curran
Author URI: http://suburbia.org.uk
*/

add_action('admin_init', 'reg_tax'); // Enable the Category field for Attachments, this is then hidden via CSS, category values are entered into it via Javascript
function reg_tax() {
   register_taxonomy_for_object_type('category', 'attachment');
   add_post_type_support('attachment', 'category');
}


function wos_media_categories($args) {
        $cat_test = get_post($_GET['attachment_id'])->post_category;
		
		$categories = get_categories('hide_empty=0'); // Get all available Categories
		$post_categories = wp_get_post_categories($_GET['attachment_id']); // Get this posts' Categories
		
		$all_cats .= '<ul id="wos-media-categories-list" style="width:500px;">'; 
		
		foreach ($categories as $category) {
			if (in_array($category->term_id, $post_categories)) {
				$chk = ' checked="checked"';
			} else {
				$chk = '';	
			}
			$option = '<li style="width:240px;float:left;"><input type="checkbox" class="wos-categories-cb" value="'.$category->category_nicename.'" id="'.$category->category_nicename.'" name="'.$category->category_nicename.'"'.$chk.'> ';
			$option .= '<label for="'.$category->category_nicename.'">'.$category->cat_name.'</label>';
			$option .= '</li>';
			$all_cats .= $option;
		}
		$all_cats .= '</ul>';
		
        // Format Category fields on page
        $categories = array('all_categories' => array (
                'label' => __('Category'),
                'input' => 'html',
                'html' => $all_cats
        ));

        return array_merge($args, $categories);
}

add_filter('attachment_fields_to_edit', 'wos_media_categories', 5);

if (is_admin()) { // Only load if in the admin area
	$jsfile = '/wos-media-categories/wos-media-categories.js';
	$cssfile = '/wos-media-categories/wos-media-categories.css';
	if (file_exists(WP_PLUGIN_DIR.$jsfile)) {
		wp_register_script('wos_mediacategories_js', WP_PLUGIN_URL.$jsfile);
		wp_enqueue_script('wos_mediacategories_js');
	}
	if (file_exists(WP_PLUGIN_DIR.$cssfile)) {
		wp_register_style('wos_mediacategories_css', WP_PLUGIN_URL.$cssfile);
		wp_enqueue_style( 'wos_mediacategories_css');
	}
}

?>